#red turnip - a modular irc bot written in ruby
#Copyright (C) 2003 cyndis
    
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

class TurnipMessage
	def initialize(message)
		@message = message.strip
	end
	def to_s
		return @message
	end
	def getNick
		return @message.split('!')[0].split(':')[1]
	end
	def getIdent
		return @message.split('!')[1].split('@')[0]
	end
	def getHost
		return @message.split('@')[1].split(' ')[0]
	end
	def getMethod
		return @message.split(' ')[1]
	end
	def getTarget
		return @message.split(' ')[2]
	end
	def isChan?
		if (self.getTarget[0] == 35)
			return true
		else
			return false
		end
	end
	def getSendTarget
		if (not self.isChan?)
			return self.getNick
		else
			return self.getTarget
		end
	end
	def getMessage
		if (@message.split(' ')[0] != 'PING')
			return @message[@message.index(':',1)+1..@message.length]
		else
			return @message.split(':')[1]
		end
	end
	def isPing?
		return (@message.split(' ')[0] == "PING" ? true : false)
	end
	def isRaw?(raw)
		if (@message.split(' ')[1] == raw)
			return true
		else
			return false
		end
	end
	def message
		return @message
	end
	def getMessageParams(paramnum)
		msg = self.getMessage
		start = msg.split(' ')[0..paramnum].join(" ").length + 1
		ret = msg[start..msg.length]
		return ret
	end
end

class TurnipSocket < TCPSocket
	def irc_puts(message)
		if (@irc_puts_handler == nil)
			self.puts message
         $stdout.print "TurnipSocket::irc_puts: ", message.to_s, "\n"
		else
			@irc_puts_handler.call(message)
		end
	end
	def override_irc_puts(handler)
		@irc_puts_handler = handler
	end
	def irc_gets
		if (@irc_gets_handler == nil)
			begin
			  ret = self.gets
			rescue Errno::EINVAL
		          ret = nil
			end
			if (ret == nil or ret == false)
				return nil
			end
			return TurnipMessage.new(ret)
		else
			@irc_gets_handler.call(message)
		end
	end
	def override_irc_gets(handler)
		@irc_gets_handler = handler
	end
	def privmsg(target,message)
		return self.irc_puts("PRIVMSG #{target} :#{message}")
	end
	def quit(message)
		return self.irc_puts("QUIT :#{message}")
	end
	def authenticate(nickname,ident,realname)
		begin
			self.puts "NICK #{nickname}"
			self.puts "USER #{ident} * * :#{realname}"
			return true
		rescue
			return false
		end
	end
end

def irc_connect(host,port = 6667)
	begin
		socket = TurnipSocket.new(host,port)
		return socket
	rescue
		return false
	end
end
