require 'test/unit'
require 'controlbot'

# Relevant agents must be started before running this test.
class TestControlbot < Test::Unit::TestCase

  def setup
    @agent = ControlBot.new
  end

  def test_alice
    actual = @agent.send("Alice: if response =~ /JUDGE/ then score = 0 end")
    assert_match(/Okay/, actual)
  end

  def test_link
    actual = @agent.send('link: what is the subject of "I like traffic lights."')
    assert_match(/\bI\b/, actual)
    actual = @agent.send('link: what is the verb in: "I like traffic lights."')
    assert_match(/\blike\b/, actual)
  end

  def test_monty
    actual = @agent.send('monty: help')
    assert_match(/montylingua/i, actual)

    actual = @agent.send('subject: John ate an apple.')
    assert_match(/John/, actual)

    actual = @agent.send('monty: what is the object in John ate an apple.')
    assert_match(/an apple/, actual)
  end

  def test_delay
    actual = @agent.send('controlbot: set the delay to 0.5')
    assert_match(/0\.5/, actual)

    actual = @agent.send('controlbot: what is the delay set to?')
    assert_match(/0\.5/, actual)
  end

  def test_sleep
    actual = @agent.send('controlbot: set sleep to 0.5')
    assert_match(/0\.5/, actual)

    actual = @agent.send('controlbot: what is your sleep value?')
    assert_match(/0\.5/, actual)
  end

end
